Attribute VB_Name = "modWinSlide"
Option Explicit

' movement style '
Public modStyle As Integer
' public constants for movement style (0 = default) '
Public Const vbBottomSide = 0
Public Const vbTopSide = 1
Public Const vbLeftSide = 2
Public Const vbRightSide = 3
Public Const vbHideIt = 4
' public constant for ending location '
' true = center screen                '
' false = peek over the edge          '
Public modCenterStop As Boolean
Public modWorkAreaHeight As Long
Public modWorkAreaWidth As Long
Public TppX As Long
Public TppY As Long
Public FormLeft As Long
Public FormTrackStart As Long
Public FormTrackEnd As Long
Public Type RECT
     Left As Long
     Top As Long
     Right As Long
     Bottom As Long
End Type
Public Const SPI_GETWORKAREA = 48
Declare Function SystemParametersInfo Lib "user32" Alias "SystemParametersInfoA" (ByVal uAction As Long, ByVal uParam As Long, lpvParam As Any, ByVal fuWinIni As Long) As Long

Public Sub InitWindow(wnd As Form)
Dim lRet As Long
Dim apiRECT As RECT
TppX = Screen.TwipsPerPixelX
TppY = Screen.TwipsPerPixelY
lRet = SystemParametersInfo(SPI_GETWORKAREA, vbNull, apiRECT, 0)
          modWorkAreaWidth = (apiRECT.Right - apiRECT.Left) * TppX
          modWorkAreaHeight = (apiRECT.Bottom - apiRECT.Top) * TppY
End Sub
 
'                                                         '
' Use: Call SlideWindow(wnd,modStyle,modCenterStop)       '
'                                                         '
' wnd = Name of form to slide.    (aka: wnd=Me)           '
'                                                         '
' modCenterStop As Boolean : Slide to centerscreen (true) '
'                       :  Peek over the edge   (false)   '
'                                                         '
' modStyle As Const: vbBottomSide (0) Enter from bottom   '
'                  : vbTopside    (1) Enter from top      '
'                  : vbLeftSide   (2) Enter from left     '
'                  : vbRightSide  (3) Enter from right    '
'                  : vbHideIt     (4) Drop from screen    '
'                                                         '

Public Sub SlideWindow(wnd As Form, modStyle As Integer, modCenterStop As Boolean)
Dim x As Long
Dim y As Long
Dim TrackStart As Long
Dim TrackStart2 As Long
Dim TrackEnd As Long
Dim TrackEnd2 As Long
Dim FormHeight As Long
Dim FormWidth As Long
Dim FormTop As Long
Dim FormLeft As Long
Dim valStep As Long
Call InitWindow(wnd)
' vbBottomSide '
If modStyle = vbBottomSide Then
    FormHeight = wnd.Height
    FormLeft = (Screen.Width / 2) - (wnd.Width / 2)
    wnd.Top = Screen.Height + 100
    TrackStart = wnd.Top
    
        If modCenterStop = False Then
            TrackEnd = Screen.Height - (Screen.Height - modWorkAreaHeight) - FormHeight
        Else
            TrackEnd = GetCenterScreenY - GetFormTop(wnd)
        End If
        
    For x = TrackStart To TrackEnd Step -1
        wnd.Left = FormLeft
        wnd.Top = x
        DoEvents
    Next x
Exit Sub
End If

' vbTopSide '
If modStyle = vbTopSide Then
    FormHeight = wnd.Height
    FormLeft = (Screen.Width / 2) - (wnd.Width / 2)
    wnd.Top = wnd.Top - 100
    TrackStart = 0 - FormHeight
    If modCenterStop = False Then
        TrackEnd = TrackStart + FormHeight
    Else
        TrackEnd = GetCenterScreenY - GetFormTop(wnd)
    End If
    For x = TrackStart To TrackEnd
        wnd.Left = FormLeft
        wnd.Top = x
        DoEvents
    Next x
Exit Sub
End If

' vbLeftSide '
If modStyle = vbLeftSide Then
    FormHeight = wnd.Height
    FormWidth = wnd.Width
    FormLeft = 1 - FormWidth
    TrackStart = FormLeft
    If modCenterStop = False Then
        TrackEnd = 1
    Else
        TrackEnd = GetCenterScreenX - GetFormLeft(wnd)
    End If
    wnd.Top = GetCenterScreenY - GetFormTop(wnd)
    For x = TrackStart To TrackEnd
        wnd.Left = x
        wnd.Top = GetCenterScreenY - GetFormTop(wnd)
        DoEvents
    Next x
Exit Sub
End If

' vbRightSide '
If modStyle = vbRightSide Then
    FormHeight = wnd.Height
    FormWidth = wnd.Width
    FormLeft = GetCenterScreenX - GetFormLeft(wnd)
    wnd.Top = wnd.Top - 100
    TrackStart = (modWorkAreaWidth + 100)
    If modCenterStop = False Then
        TrackEnd = Screen.Width - wnd.Width
    Else
        TrackEnd = GetCenterScreenX - GetFormLeft(wnd)
    End If
    For x = TrackStart To TrackEnd Step -1
        wnd.Left = x
        wnd.Top = GetCenterScreenY - GetFormTop(wnd)
        DoEvents
    Next x
Exit Sub
End If

' hide it '
If modStyle = vbHideIt Then
For x = wnd.Top To Screen.Height + 100
    wnd.Top = x
    DoEvents
Next x
End If
End Sub

' find horizontal center of screen '
Public Function GetCenterScreenX() As Long
GetCenterScreenX = Screen.Width / 2
End Function

' find vertical center of screen '
Public Function GetCenterScreenY() As Long
GetCenterScreenY = Screen.Height / 2
End Function

' figure half the fomm height '
Public Function GetFormTop(wnd2 As Form) As Long
GetFormTop = wnd2.Height / 2
End Function

' figure half the form width '
Public Function GetFormLeft(wnd3 As Form) As Long
GetFormLeft = wnd3.Width / 2
End Function
